typedef struct {
  thread_id     pid;        // Prozess-ID
  thread_id     tid;        // Thread-ID
  thread_id     ppid;       // Parent-Prozess
  int           state;      // Prozesszustand
  context_t     regs;       // Kontext
  addr_space_id addr_space; // Address-Space-ID
  thread_id     next;       // ID des `nächsten' bzw.
  thread_id     prev;       // ... `vorherigen' Thread
  boolean       used;
  int           error;
  int           exitcode;
  int           waitfor;    // PID des Kindprozess, auf
                            // den dieser Prozess wartet
  char          cmdline[CMDLINE_LENGTH];
  boolean       new;        // Ist das ein neuer Thread?
  int           terminal;
  int           files[MAX_PFD];
  char          cwd[256];
  sighandler_t  sighandlers[32];
  unsigned long sig_pending;
  unsigned long sig_blocked;
  word          uid, gid ;  // User- und Gruppen-IDs
  word          euid, egid; // effektive User-/Gr.-IDs
  word          ruid, rgid; // reale User-/Gr.-IDs
} TCB;

