#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#define WAIT 100

int glob = 0;

sem_t *mutex;    // Deklaration des Semaphors

float waste_time () {
  int j; float tmp[100];
  for (j = 0; j < 100; j++) tmp[j] = (0.1+j) * (100.1+j);
  for (j = 0; j < 99; j++) tmp[j+1] += (100.1+j) * tmp[j];
  return tmp[99];
}

void *sub (void *args) {
  sem_wait (mutex);  // Mutex für glob locken
  int local = glob;  // echte lokale Variable
  int j; for (j = 0; j < 20; j++) {
    printf ("-"); fflush (stdout); local--;
  }
  for (j = 0; j < WAIT; j++) waste_time ();
  glob = local;
  sem_post (mutex);  // Mutex freigeben
}

void *add (void *args) {
  sem_wait (mutex);  // Mutex für glob locken
  int local = glob;  // echte lokale Variable
  int j; for (j = 0; j < 20; j++) {
    printf ("+"); fflush (stdout); local++;
  }
  for (j = 0; j < WAIT; j++) waste_time ();
  glob = local;
  sem_post (mutex);  // Mutex freigeben
}

int main () {
  pthread_t threads[100];
  mutex = sem_open ("/s", O_CREAT, 0644, 1);  // init.
       
  int i; int oldglob = glob;

  // Threads erzeugen
  for (i = 0;  i < 50;  i++)
    pthread_create (&threads[i], NULL, add, NULL);
  for (i = 50; i < 100; i++)
    pthread_create (&threads[i], NULL, sub, NULL);
  
  // Threads einsammeln
  for (i = 0;  i < 100;  i++)
    pthread_join (threads[i], NULL);
    
  printf ("\nStartwert: %d\n", oldglob);
  printf ("Endwert: %d\n", glob);
  
  sem_close (mutex);  // Mutex zerstören
}

