#include <stdio.h>    // printf()
#include <signal.h>   // signal(), SIGUSR1
#include <unistd.h>   // sleep()

int glob = 0;

void sigusr1_handler (int sig) {
  glob++;
  printf ("Sie haben mir das Signal USR1 geschickt. "
          "Ich erhöhe glob auf %d\n", glob);
  return;
}

int main () {
  printf ("Signal-Handler-Test\n");
  signal (SIGUSR1, sigusr1_handler);  // Handler eintragen
  for (;;) {
    printf ("glob hat den Wert %d.\n", glob);
    sleep (1);
  }
}

