#include <stdio.h>
#include <pthread.h>

#define WAIT 100
int glob = 0;
pthread_mutex_t mutex;    // Deklaration des Mutex

float waste_time () {
  int j; float tmp[100];
  for (j = 0; j < 100; j++) tmp[j] = (0.1+j) * (100.1+j);
  for (j = 0; j < 99; j++) tmp[j+1] += (100.1+j) * tmp[j];
  return tmp[99];
}

void *sub (void *args) {
  pthread_mutex_lock (&mutex);  // Mutex für glob locken
  int local = glob;   // echte lokale Variable
  int j; for (j = 0; j < 20; j++) {
    printf ("-"); fflush (stdout); local--;
  }
  for (j = 0; j < WAIT; j++) waste_time ();
  glob = local;
  pthread_mutex_unlock (&mutex);  // Mutex freigeben
}

void *add (void *args) {
  pthread_mutex_lock (&mutex);  // Mutex für glob locken
  int local = glob;  // echte lokale Variable
  int j; for (j = 0; j < 20; j++) {
    printf ("+"); fflush (stdout); local++;
  }
  for (j = 0; j < WAIT; j++) waste_time ();
  glob = local;
  pthread_mutex_unlock (&mutex);  // Mutex freigeben
}

int main () {
  pthread_t threads[100];
  int i; int oldglob = glob;

  pthread_mutex_init (&mutex, NULL);   // Mutex init.

  // Threads erzeugen
  for (i = 0;  i < 50;  i++)
    pthread_create (&threads[i], NULL, add, NULL);
  for (i = 50; i < 100; i++)
    pthread_create (&threads[i], NULL, sub, NULL);
  
  // Threads einsammeln
  for (i = 0; i < 100; i++) pthread_join (threads[i], NULL);
    
  printf ("\nStartwert: %d\n", oldglob);
  printf ("Endwert: %d\n", glob);
  
  pthread_mutex_destroy (&mutex);   // Mutex zerstören
}


