#include <unistd.h>
#include <stdio.h>
int main () {
  int pipefds[2];        // Pipe-Dateideskriptoren
  pipe (pipefds);        // Pipe erzeugen
  int fd0 = pipefds[0];  // Deskriptor zum Lesen
  int fd1 = pipefds[1];  // Deskriptor zum Schreiben
  if (fork() != 0) {
    // Vaterprozess
    close (fd0);         // nicht benötigtes Ende schließen
    write (fd1, "Hallo Welt", sizeof ("Hallo Welt"));
  } else {
    // Kindprozess
    close (fd1);         // nicht benötigtes Ende schließen
    char buffer[20];
    read (fd0, buffer, 20);
    printf ("Nachricht: %s\n", buffer);
  }
}

