#include <stdlib.h>
#include <string.h>
#include <stdio.h>

struct student {
  int  matrikelnummer;
  char name[100];
};

struct student *studenten;          // Studenten-Array
int anzahl;                         // aktuelle Array-Größe

void init (int n) {
  anzahl = n;
  studenten = calloc (anzahl, sizeof(struct student));
}

// Eintrag auslesen
void get (int pos, int *matrikelnummer, char *name) {
  *matrikelnummer = studenten[pos].matrikelnummer;
  strncpy (name, studenten[pos].name, 100);
}

// Eintrag schreiben
void put (int pos, int matrikelnummer, char *name) {
  if (pos > anzahl) {
    // hinter aktueller Grenze -> Array vergrößern!
    void *tmp = realloc (studenten, 
                         (pos+1) * sizeof(struct student));
    if (tmp == NULL) exit (1);      // Speicher voll
    studenten = tmp;
  }
  studenten[pos].matrikelnummer = matrikelnummer;
  strncpy (studenten[pos].name, name, 100);
}

int main () {
  init (50);                        // anfangs 50 Elemente
  put ( 0, 12345, "Anton Maier");
  put (70, 12346, "Maria Schmitz"); // vergrößert Array
  char s_name[100]; int s_matr;
  get (70, &s_matr, s_name);
  printf ("Name: '%s', Matr.Nr.: %d\n", s_name, s_matr);
}

