#include <stdio.h>    // printf
#include <unistd.h>   // sleep
#include <stdlib.h>   // malloc

char      chararray[1024]; // BSS-Segment  (nicht init.)
const int i = 7;           // Text-Segment (konstant)
int       j = 4095;        // Daten-Segment (initialisiert)

void testfunc () {
  int array[4096];         // Stack
  array[i] = 3; array[j] = 5;
  chararray[1] = 'B';
  printf ("&array     = %8p\n", array);
  printf ("Test: %d, %d\n", array[i], array[j]);
}

int main () {
  printf ("&chararray = %p\n", chararray);
  printf ("&i         = %p\n", &i);
  printf ("&j         = %p\n", &j);
  
  chararray[0] = 'A'; chararray[2] = '\0';
  testfunc ();
  printf ("Test: %s\n", chararray);
  char *s = malloc (40*1024*1024);  // 40 MByte, Heap
  printf ("s (ptr)    = %p\n", s);
  sleep (20);
  return 0;
}

